/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Geneticky_algoritmus;

import Funkce.Funkce;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Random;

/**
 *
 * @author Miraxp
 */
public class Generace {

    private List<Jedinec> jedinci;
    private int pocetJedincu, pocetGenuJedince, pocetBituJedince = 0;
    private double parametryJedince[][], pravdepodobnostMutace;
    private String[] maxGenuJedinceBinarne;
    private long[] maxGenuJedinceDekadicky;
    private Funkce fitness;
    private short pocetPrezivsich;
    private short typVyberu;
    private static Comparator<Jedinec> pComparator;

    public Generace(int novyPocetJedincu, double noveParametryJedince[][], double novaPravdepodobnostMutace, Funkce novaFitness, int noveProcentoPrezivsich, short novyTypVyberu) {
        this.pocetJedincu = novyPocetJedincu;
        this.parametryJedince = noveParametryJedince;
        this.pocetGenuJedince = parametryJedince.length;
        this.pravdepodobnostMutace = novaPravdepodobnostMutace;
        this.fitness = novaFitness;

        this.jedinci = new ArrayList(pocetJedincu);

        pComparator = new Comparator<Jedinec>() {

            public int compare(Jedinec jedinec_1, Jedinec jedinec_2) {
                double hJedinec1 = jedinec_1.dejHodnoceni();
                double hJedinec2 = jedinec_2.dejHodnoceni();
                if (hJedinec1 == hJedinec2) {
                    return 0;
                } else if (hJedinec1 > hJedinec2) {
                    return -1;
                } else {
                    return 1;
                }
            }
        };
        if (noveProcentoPrezivsich < 0) {
            noveProcentoPrezivsich = 0;
        }
        if (noveProcentoPrezivsich > 100) {
            noveProcentoPrezivsich = 100;
        }

        pocetPrezivsich = (short) (((double) pocetJedincu / 100) * (double) noveProcentoPrezivsich);
        typVyberu = novyTypVyberu;

        generujJedinceGenerace();
        ohodnotJedinceGenerace();
        seradJedince();
        if (typVyberu == 2) {
            nastavPravdepodobnost();
        }
    }

    private Generace(Generace predchoziGenerace) {
        this.pocetJedincu = predchoziGenerace.pocetJedincu;
        this.parametryJedince = predchoziGenerace.parametryJedince;
        this.pocetGenuJedince = predchoziGenerace.pocetGenuJedince;
        this.pravdepodobnostMutace = predchoziGenerace.pravdepodobnostMutace;
        this.fitness = predchoziGenerace.fitness;
        this.pocetBituJedince = predchoziGenerace.pocetBituJedince;

        this.maxGenuJedinceDekadicky = predchoziGenerace.maxGenuJedinceDekadicky;
        this.maxGenuJedinceBinarne = predchoziGenerace.maxGenuJedinceBinarne;
        this.jedinci = new ArrayList(pocetJedincu);

        this.pocetPrezivsich = predchoziGenerace.pocetPrezivsich;
        this.typVyberu = predchoziGenerace.typVyberu;

        generujGeneraciJednobodKriz(predchoziGenerace);
        ohodnotJedinceGenerace();
        seradJedince();
        if (typVyberu == 2) {
            nastavPravdepodobnost();
        }
    }

    private void generujJedinceGenerace() {
        this.maxGenuJedinceDekadicky = vypocitejMaxGenuJedinceDekadicky();
        this.maxGenuJedinceBinarne = vypocitejMaxGenuJedinceBinarne();
        for (int aktJedinec = 0; aktJedinec < pocetJedincu; aktJedinec++) {
            jedinci.add(new Jedinec(generujChromozomJedince()));
        }
    }

    private StringBuffer generujChromozomJedince() {
        int pocetBituGenu;
        StringBuffer novyChromozom = new StringBuffer();
        Random nahodneCislo = new Random();
        for (int aktGen = 0; aktGen < pocetGenuJedince; aktGen++) {
            pocetBituGenu = maxGenuJedinceBinarne[aktGen].length();
            for (int aktBit = 0; aktBit < pocetBituGenu; aktBit++) {
                novyChromozom.append(Integer.toString(nahodneCislo.nextInt(2)));
            }
        }
        pocetBituJedince = novyChromozom.length();
        return novyChromozom;
    }

    private long[] vypocitejMaxGenuJedinceDekadicky() {
        long maxDekadicky[] = new long[pocetGenuJedince];
        for (int aktGen = 0; aktGen < pocetGenuJedince; aktGen++) {
            maxDekadicky[aktGen] = (long) ((parametryJedince[aktGen][1] - parametryJedince[aktGen][0]) * Math.pow(10, parametryJedince[aktGen][2]));
        }
        return maxDekadicky;
    }

    private String[] vypocitejMaxGenuJedinceBinarne() {
        String MaxGenuJedinceBinarne[] = new String[pocetGenuJedince];
        for (int aktGen = 0; aktGen < pocetGenuJedince; aktGen++) {
            MaxGenuJedinceBinarne[aktGen] = new String(Long.toBinaryString(maxGenuJedinceDekadicky[aktGen]));
        }
        return MaxGenuJedinceBinarne;
    }

    public StringBuffer dejChromozomJedince(int index) {
        return jedinci.get(index).dejChromozom();
    }

    private void ohodnotJedinceGenerace() {
        for (int aktJedinec = 0; aktJedinec < pocetJedincu; aktJedinec++) {
            jedinci.get(aktJedinec).nastavHodnoceni(dejHodnotuJedince(aktJedinec));
        }
    }

    private double dejHodnoceniJedince(int index) {
        return jedinci.get(index).dejHodnoceni();
    }

    private double dejHodnotuJedince(int index) {
        return -1 * fitness.f(dejPoleGenuJedince(index));
    }

    private double[] dejPoleGenuJedince(int index) {
        double[] poleGenu = new double[pocetGenuJedince];
        StringBuffer chromozomJedince = jedinci.get(index).dejChromozom();
        String genJedince;
        long genDekadicky;
        int pocetBituGenu;
        for (int aktGen = 0; aktGen < pocetGenuJedince; aktGen++) {
            pocetBituGenu = maxGenuJedinceBinarne[aktGen].length();
            genJedince = chromozomJedince.substring(aktGen * pocetBituGenu, (aktGen + 1) * pocetBituGenu);
            genDekadicky = Long.parseLong(genJedince, 2);
            poleGenu[aktGen] = genDekadicky / Math.pow(10, parametryJedince[aktGen][2]) + parametryJedince[aktGen][0];
        }
        return poleGenu;
    }

    private void nastavPravdepodobnost() {
        double min = jedinci.get(pocetJedincu - 1).dejHodnoceni();
        double soucetHodnoceni = 0;
        for (int aktJedinec = 0; aktJedinec < pocetJedincu; aktJedinec++) {
            soucetHodnoceni += jedinci.get(aktJedinec).dejHodnoceni() - min;
        }
        for (int aktJedinec = 0; aktJedinec < pocetJedincu; aktJedinec++) {
            jedinci.get(aktJedinec).nastavPravdepodobnost((jedinci.get(aktJedinec).dejHodnoceni() - min) / soucetHodnoceni);
        }
    }

    private int vyberJedinceRuleta() {
        double intervalJedinceMin = 0;
        double intervalJedinceMax = 0;
        Random nahodneCislo = new Random();
        double ukazatel = nahodneCislo.nextDouble();
        for (int aktJedinec = 0; aktJedinec < pocetJedincu; aktJedinec++) {
            intervalJedinceMax = intervalJedinceMin + jedinci.get(aktJedinec).dejPravdepodobnost();
            if (ukazatel >= intervalJedinceMin && ukazatel < intervalJedinceMax) {
                return aktJedinec;
            }
            intervalJedinceMin = intervalJedinceMax;
        }
        return 0;
    }

    private int vyberJedinceTurnaj() {
        Random nahodneCislo = new Random();
        int indexSoupere1, indexSoupere2;
        indexSoupere1 = nahodneCislo.nextInt(pocetJedincu);
        do {
            indexSoupere2 = nahodneCislo.nextInt(pocetJedincu);
        } while (indexSoupere2 == indexSoupere1);
        if (dejHodnoceniJedince(indexSoupere1) > dejHodnoceniJedince(indexSoupere2)) {
            return indexSoupere1;
        } else {
            return indexSoupere2;
        }
    }

    private Jedinec[] zkrizJednobodove() {
        Random nahodneCislo = new Random();
        Jedinec predek1, predek2;

        if (this.typVyberu == 1) {
            predek1 = jedinci.get(vyberJedinceTurnaj());
            do {
                predek2 = jedinci.get(vyberJedinceTurnaj());
            } while (predek2 == predek1);
        } else {
            predek1 = jedinci.get(vyberJedinceRuleta());
            predek2 = jedinci.get(vyberJedinceRuleta());
        }
        StringBuffer chromozomPredka1 = predek1.dejChromozom();
        StringBuffer chromozomPredka2 = predek2.dejChromozom();
        StringBuffer chromozomPotomka1 = new StringBuffer();
        StringBuffer chromozomPotomka2 = new StringBuffer();
        int mez = nahodneCislo.nextInt(pocetBituJedince);
        for (int aktBit = 0; aktBit < pocetBituJedince; aktBit++) {
            if (aktBit <= mez) {
                chromozomPotomka1.append(chromozomPredka1.charAt(aktBit));
                chromozomPotomka2.append(chromozomPredka2.charAt(aktBit));
            } else {
                chromozomPotomka1.append(chromozomPredka2.charAt(aktBit));
                chromozomPotomka2.append(chromozomPredka1.charAt(aktBit));
            }
        }
        return new Jedinec[]{new Jedinec(chromozomPotomka1), new Jedinec(chromozomPotomka2)};
    }

    public Generace vytvorGeneraciJednobodovymKrizenim() {
        return new Generace(this);
    }

    private void generujGeneraciJednobodKriz(Generace predchoziGenerace) {
        Jedinec[] potomci;
        for (int aktJedinec = 0; aktJedinec < pocetPrezivsich; aktJedinec++) {
            jedinci.add(predchoziGenerace.dejJedince(aktJedinec));
        }
        Random nahodneCislo = new Random();
        for (int pocetNovychJed = pocetPrezivsich; pocetNovychJed < pocetJedincu; pocetNovychJed += 2) {
            potomci = predchoziGenerace.zkrizJednobodove();
            jedinci.add(potomci[0]);
            if (nahodneCislo.nextDouble() < pravdepodobnostMutace) {
                jedinci.get(pocetNovychJed).mutaceChromozomu();
            }
            if (pocetNovychJed + 1 < pocetJedincu) {
                jedinci.add(potomci[1]);
                if (nahodneCislo.nextDouble() < pravdepodobnostMutace) {
                    jedinci.get(pocetNovychJed + 1).mutaceChromozomu();
                }
            }
        }
    }

    public double[] dejPoleGenuNejlepsihoJedince() {
        return this.dejPoleGenuJedince(0);
    }

    public boolean jsouVsichniJedinciStejni() {
        StringBuffer chromozom = jedinci.get(0).dejChromozom();
        for (int aktJedinec = 0; aktJedinec < pocetJedincu; aktJedinec++) {
            if (chromozom != jedinci.get(aktJedinec).dejChromozom()) {
                return false;
            }
            chromozom = jedinci.get(aktJedinec).dejChromozom();
        }
        return true;
    }

    public boolean jeHodnoceniVsechStejne() {
        double hodnoceni = jedinci.get(0).dejHodnoceni();
        for (int aktJedinec = 0; aktJedinec < pocetJedincu; aktJedinec++) {
            if (hodnoceni != jedinci.get(aktJedinec).dejHodnoceni()) {
                return false;
            }
            hodnoceni = jedinci.get(aktJedinec).dejHodnoceni();
        }
        return true;
    }

    public void seradJedince() {
        Collections.sort(jedinci, pComparator);
    }

    private Jedinec dejJedince(int index) {
        return jedinci.get(index);
    }

    private double vypocitejSoucetHodnot() {
        double soucetHodnot = 0;
        for (int aktJedinec = 0; aktJedinec < pocetJedincu; aktJedinec++) {
            soucetHodnot += dejHodnotuJedince(aktJedinec);
        }
        return soucetHodnot;
    }

    public double vypocitejPrumerneHodnoceni() {
        return vypocitejSoucetHodnot() / (double) pocetJedincu;
    }
}
