/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * JPanelGraf.java
 *
 * Created on 5.4.2011, 22:47:14
 */
package Graficka_aplikace;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import javax.swing.JLabel;

/**
 *
 * @author Miraxp
 */
public class JPanelGraf extends javax.swing.JPanel {

    private JPanelVstup panelVstupniData;
    private JPanelVystup panelVystupniData;
    private JPanelLegenda panelLegenda;
    private JLabel cas;
    private double hodnotyY[], hodnotyU[], hodnotyYGenetic[], hodnotyYNelder[], hodnotyYCtverce[];
    private int pocetHodnotY, pocetHodnotU, pocetHodnotGenetic, pocetHodnotNelder, pocetHodnotCtverce;
    private double maxX, maxY, minY, pomerX, pomerY;
    private int hodnotyXVykr[], hodnotyXVykrU[], hodnotyYVykr[], hodnotyUVykr[], hodnotyYGeneticVykr[], hodnotyYNelderVykr[], hodnotyYCtverceVykr[];
    private int sirkaOsy, vyskaOsy;
    private double velikostZnacky;

    /** Creates new form JPanelGraf */
    public JPanelGraf(JPanelVstup novyPanelVstupniData, JPanelVystup novyPanelVystupniData, JPanelLegenda novyPanelLegenda) {
        initComponents();
        panelVstupniData = novyPanelVstupniData;
        panelVystupniData = novyPanelVystupniData;
        panelLegenda = novyPanelLegenda;

        sirkaOsy = 75;
        vyskaOsy = 51;
        velikostZnacky = 50;

        aktualizujGraf();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    @Override
    public void paintComponent(Graphics g) {
        this.removeAll();

        vypoctiMinMaxY();
        vytvorDataVykr();
        vypoctiPomer();
        vypoctiHodnotyVykr();

        g.setColor(Color.white);
        g.fillRect(0 + sirkaOsy, 0, getWidth(), getHeight() - vyskaOsy);
        g.setColor(Color.black);
        g.drawLine(0, getHeight() - 1, getWidth(), getHeight() - 1);


// Graf u
        if (panelLegenda.CheckBoxU()) {
            g.setColor(Color.cyan);
            g.drawPolyline(hodnotyXVykrU, hodnotyUVykr, pocetHodnotU);
        }
// Graf ymk
        if (panelLegenda.CheckBoxY()) {
            g.setColor(Color.green);
            g.drawPolyline(hodnotyXVykr, hodnotyYVykr, pocetHodnotY);
        }
// Graf geneticky algoritmus
        if (panelLegenda.CheckBoxYGenetic()) {
            g.setColor(Color.red);
            g.drawPolyline(hodnotyXVykr, hodnotyYGeneticVykr, pocetHodnotGenetic);
        }
// Graf nelder-mead
        if (panelLegenda.CheckBoxYNelder()) {
            g.setColor(Color.blue);
            g.drawPolyline(hodnotyXVykr, hodnotyYNelderVykr, pocetHodnotNelder);
        }
// Graf ctverce
        if (panelLegenda.CheckBoxYCtverce()) {
            g.setColor(Color.magenta);
            g.drawPolyline(hodnotyXVykr, hodnotyYCtverceVykr, pocetHodnotCtverce);
        }
// souradnice XY
        int vyska = getHeight() - vyskaOsy - 2;
        int sirka = getWidth() - sirkaOsy - 2;
        double krokX;
        if (maxX > 0) {
            krokX = (maxX - 1) * velikostZnacky / (double) sirka;
        } else {
            krokX = 0;
        }
        double krokY = (maxY - minY) * velikostZnacky / (double) vyska;
        int maxXVykr = (int) (sirkaOsy + maxX * pomerX);
        int maxYVykr = (int) (vyska - pomerY * (maxY - minY));
        g.setColor(Color.black);
// X
        g.drawLine(0 + sirkaOsy, vyska + 1, getWidth(), vyska + 1);
        JLabel znackaX;
        double aktHodnotaX = 1;
        for (int aktZnackaX = sirkaOsy + 1; aktZnackaX <= maxXVykr; aktZnackaX += velikostZnacky) {
            znackaX = new JLabel(Double.toString(Prevod.prevodNaNMist(aktHodnotaX, 1)));
            znackaX.setFont(new Font("SansSerif", Font.PLAIN, 10));
            znackaX.setHorizontalAlignment(JLabel.CENTER);
            znackaX.setSize(45, 10);
            znackaX.setLocation(aktZnackaX - 22, vyska + 10);
            add(znackaX);
            g.drawLine(aktZnackaX, vyska + 5, aktZnackaX, vyska + 1);
            aktHodnotaX += krokX;
        }
        cas = new JLabel("Diskrétní čas");
        cas.setSize(100, 20);
        cas.setLocation(getWidth() - 110, getHeight() - 25);
        cas.setHorizontalAlignment(JLabel.RIGHT);
        add(cas);
// Y
        g.drawLine(0 + sirkaOsy, 0, 0 + sirkaOsy, vyska + 1);
        JLabel znackaY;
        double aktHodnotaY = minY;
        for (int aktZnackaY = (int) vyska; aktZnackaY >= maxYVykr; aktZnackaY -= velikostZnacky) {
            znackaY = new JLabel(Double.toString(Prevod.prevod(aktHodnotaY, 10)));
            znackaY.setFont(new Font("SansSerif", Font.PLAIN, 10));
            znackaY.setHorizontalAlignment(JLabel.RIGHT);
            znackaY.setSize(68, 10);
            znackaY.setLocation(0, aktZnackaY - 5);
            add(znackaY);
            g.drawLine(sirkaOsy - 4, aktZnackaY, sirkaOsy, aktZnackaY);
            aktHodnotaY += krokY;
        }
    }

    public void aktualizujGraf() {
        nastavVstupniData();
        vypoctiMaxX();
    }

    private void nastavVstupniData() {
        hodnotyY = panelVstupniData.dejPoleDatY();
        hodnotyU = panelVstupniData.dejPoleDatU();
        hodnotyYGenetic = panelVystupniData.dejPoleDatGenetic();
        hodnotyYNelder = panelVystupniData.dejPoleDatNelder();
        hodnotyYCtverce = panelVystupniData.dejPoleDatCtverce();

        pocetHodnotY = hodnotyY.length;
        pocetHodnotU = hodnotyU.length;
        pocetHodnotGenetic = hodnotyYGenetic.length;
        pocetHodnotNelder = hodnotyYNelder.length;
        pocetHodnotCtverce = hodnotyYCtverce.length;
    }

    private void vytvorDataVykr() {
        hodnotyYVykr = new int[pocetHodnotY];
        hodnotyUVykr = new int[pocetHodnotU];
        hodnotyYGeneticVykr = new int[pocetHodnotGenetic];
        hodnotyYNelderVykr = new int[pocetHodnotNelder];
        hodnotyYCtverceVykr = new int[pocetHodnotCtverce];

        hodnotyXVykr = new int[(int) maxX];
        hodnotyXVykrU = new int[(int) maxX];
    }

    private void vypoctiMaxX() {
        if (pocetHodnotGenetic >= pocetHodnotY) {
            maxX = pocetHodnotGenetic;
        } else {
            maxX = pocetHodnotY;
        }
    }

    private void vypoctiMinMaxY() {
        boolean nastaveno = false;
        for (int aktHodnota = 0; aktHodnota < maxX; aktHodnota++) {
            if (aktHodnota < pocetHodnotY) {
                if (panelLegenda.CheckBoxU()) {
                    if (!nastaveno) {
                        minY = hodnotyU[0];
                        maxY = hodnotyU[0];
                        nastaveno = true;
                    }
                    if (hodnotyU[aktHodnota] < minY) {
                        minY = hodnotyU[aktHodnota];
                    }

                    if (hodnotyU[aktHodnota] > maxY) {
                        maxY = hodnotyU[aktHodnota];
                    }
                }
                if (panelLegenda.CheckBoxY()) {
                    if (!nastaveno) {
                        minY = hodnotyY[0];
                        maxY = hodnotyY[0];
                        nastaveno = true;
                    }
                    if (hodnotyY[aktHodnota] < minY) {
                        minY = hodnotyY[aktHodnota];
                    }

                    if (hodnotyY[aktHodnota] > maxY) {
                        maxY = hodnotyY[aktHodnota];
                    }
                }
            }

            if (aktHodnota < pocetHodnotGenetic && panelLegenda.CheckBoxYGenetic()) {
                if (!nastaveno) {
                    minY = hodnotyYGenetic[0];
                    maxY = hodnotyYGenetic[0];
                    nastaveno = true;
                }
                if (hodnotyYGenetic[aktHodnota] < minY) {
                    minY = hodnotyYGenetic[aktHodnota];
                }
                if (hodnotyYGenetic[aktHodnota] > maxY) {
                    maxY = hodnotyYGenetic[aktHodnota];
                }
            }
            if (aktHodnota < pocetHodnotNelder && panelLegenda.CheckBoxYNelder()) {
                if (!nastaveno) {
                    minY = hodnotyYNelder[0];
                    maxY = hodnotyYNelder[0];
                    nastaveno = true;
                }
                if (hodnotyYNelder[aktHodnota] < minY) {
                    minY = hodnotyYNelder[aktHodnota];
                }
                if (hodnotyYNelder[aktHodnota] > maxY) {
                    maxY = hodnotyYNelder[aktHodnota];
                }
            }
            if (aktHodnota < pocetHodnotCtverce && panelLegenda.CheckBoxYCtverce()) {
                if (!nastaveno) {
                    minY = hodnotyYCtverce[0];
                    maxY = hodnotyYCtverce[0];
                    nastaveno = true;
                }
                if (hodnotyYCtverce[aktHodnota] < minY) {
                    minY = hodnotyYCtverce[aktHodnota];
                }
                if (hodnotyYCtverce[aktHodnota] > maxY) {
                    maxY = hodnotyYCtverce[aktHodnota];
                }
            }
        }
    }

    private void vypoctiPomer() {
        if (maxX > 1) {
            pomerX = (getWidth() - sirkaOsy - 2) / (maxX - 1);
        } else {
            pomerX = 1;
        }

        if (maxY != minY) {
            pomerY = (getHeight() - vyskaOsy - 2) / (maxY - minY);
        } else {
            pomerY = 1;
        }
    }

    private void vypoctiHodnotyVykr() {
        int vyska = getHeight() - vyskaOsy;
        int hodnotaXVykrU;
        for (int aktHodnota = 0; aktHodnota < maxX; aktHodnota++) {
            hodnotyXVykr[aktHodnota] = (int) (sirkaOsy + 1 + aktHodnota * pomerX);
            if (aktHodnota < pocetHodnotY) {
                if (panelLegenda.CheckBoxY()) {
                    hodnotyYVykr[aktHodnota] = (int) (vyska - 2 - pomerY * (hodnotyY[aktHodnota] - minY));
                }
                if (aktHodnota < pocetHodnotU) {
                    if (panelLegenda.CheckBoxU()) {
                        hodnotyUVykr[aktHodnota] = (int) (vyska - 2 - pomerY * (hodnotyU[aktHodnota] - minY));

                        hodnotaXVykrU = (int) (sirkaOsy + 1 + aktHodnota * pomerX);

                        if (aktHodnota + 1 < pocetHodnotU) {
                            if (hodnotyUVykr[aktHodnota] != (int) (vyska - 2 - pomerY * (hodnotyU[aktHodnota + 1] - minY))) {
                                hodnotaXVykrU = (int) (sirkaOsy + 1 + (aktHodnota + 1) * pomerX);
                            }
                        }
                        hodnotyXVykrU[aktHodnota] = hodnotaXVykrU;
                    }
                }
            }
            if (aktHodnota < pocetHodnotGenetic && panelLegenda.CheckBoxYGenetic()) {
                hodnotyYGeneticVykr[aktHodnota] = (int) (vyska - 2 - pomerY * (hodnotyYGenetic[aktHodnota] - minY));
            }
            if (aktHodnota < pocetHodnotNelder && panelLegenda.CheckBoxYNelder()) {
                hodnotyYNelderVykr[aktHodnota] = (int) (vyska - 2 - pomerY * (hodnotyYNelder[aktHodnota] - minY));
            }
            if (aktHodnota < pocetHodnotCtverce && panelLegenda.CheckBoxYCtverce()) {
                hodnotyYCtverceVykr[aktHodnota] = (int) (vyska - 2 - pomerY * (hodnotyYCtverce[aktHodnota] - minY));
            }
        }
    }
}
