/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * JPanelGraf.java
 *
 * Created on 5.4.2011, 22:47:14
 */
package Graficka_aplikace;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import javax.swing.JLabel;

/**
 *
 * @author Miraxp
 */
public class JPanelGrafBilySum extends javax.swing.JPanel {

    private JPanelVystup panelVystupniData;
    private JPanelLegendaBilySum panelLegendaBilySum;
    private JLabel cas;
    private double hodnotySumGenetic[], hodnotySumNelder[], hodnotySumCtverce[];
    private int pocetHodnotGenetic, pocetHodnotNelder, pocetHodnotCtverce;
    private double maxX, maxY, minY, pomerX, pomerY;
    private int hodnotyXVykr[], SumGeneticVykr[], SumNelderVykr[], SumCtverceVykr[];
    private int sirkaOsy, vyskaOsy;
    private double velikostZnacky;
    private int rad;

    /** Creates new form JPanelGraf */
    public JPanelGrafBilySum(JPanelVystup novyPanelVystupniData, JPanelLegendaBilySum novyPanelLegenda) {
        initComponents();

        panelVystupniData = novyPanelVystupniData;
        panelLegendaBilySum = novyPanelLegenda;

        sirkaOsy = 75;
        vyskaOsy = 51;
        velikostZnacky = 50;

        rad = 0;
        aktualizujGraf(rad);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    @Override
    public void paintComponent(Graphics g) {
        this.removeAll();

        vypoctiMinMaxY();
        vytvorDataVykr();
        vypoctiPomer();
        vypoctiHodnotyVykr();

        g.setColor(Color.white);
        g.fillRect(0 + sirkaOsy, 0, getWidth(), getHeight() - vyskaOsy);
        g.setColor(Color.black);
        g.drawLine(0, getHeight() - 1, getWidth(), getHeight() - 1);


// Graf geneticky algoritmus
        if (panelLegendaBilySum.CheckBoxYGenetic()) {
            g.setColor(Color.red);
            g.drawPolyline(hodnotyXVykr, SumGeneticVykr, pocetHodnotGenetic);
        }
// Graf nelder-mead
        if (panelLegendaBilySum.CheckBoxYNelder()) {
            g.setColor(Color.blue);
            g.drawPolyline(hodnotyXVykr, SumNelderVykr, pocetHodnotNelder);
        }
// Graf ctverce
        if (panelLegendaBilySum.CheckBoxYCtverce()) {
            g.setColor(Color.magenta);
            g.drawPolyline(hodnotyXVykr, SumCtverceVykr, pocetHodnotCtverce);
        }
// souradnice XY
        int vyska = getHeight() - vyskaOsy - 2;
        int sirka = getWidth() - sirkaOsy - 2;
        double krokX;
        if (maxX > 0) {
            krokX = (maxX - 1) * velikostZnacky / (double) sirka;
        } else {
            krokX = 0;
        }
        double krokY = (maxY - minY) * velikostZnacky / (double) vyska;
        int maxXVykr = (int) (sirkaOsy + maxX * pomerX);
        int maxYVykr = (int) (vyska - pomerY * (maxY - minY));
        g.setColor(Color.black);
// X
        g.drawLine(0 + sirkaOsy, vyska + 1, getWidth(), vyska + 1);
        JLabel znackaX;
        double aktHodnotaX = 1;
        for (int aktZnackaX = sirkaOsy + 1; aktZnackaX <= maxXVykr; aktZnackaX += velikostZnacky) {
            znackaX = new JLabel(Double.toString(Prevod.prevodNaNMist(aktHodnotaX, 1)));
            znackaX.setFont(new Font("SansSerif", Font.PLAIN, 10));
            znackaX.setHorizontalAlignment(JLabel.CENTER);
            znackaX.setSize(45, 10);
            znackaX.setLocation(aktZnackaX - 22, vyska + 10);
            add(znackaX);
            g.drawLine(aktZnackaX, vyska + 5, aktZnackaX, vyska + 1);
            aktHodnotaX += krokX;
        }
        cas = new JLabel("Diskrétní čas");
        cas.setSize(100, 20);
        cas.setLocation(getWidth() - 110, getHeight() - 25);
        cas.setHorizontalAlignment(JLabel.RIGHT);
        add(cas);
// Y
        g.drawLine(0 + sirkaOsy, 0, 0 + sirkaOsy, vyska + 1);
        JLabel znackaY;
        double aktHodnotaY = minY;
        for (int aktZnackaY = (int) vyska; aktZnackaY >= maxYVykr; aktZnackaY -= velikostZnacky) {
            znackaY = new JLabel(Double.toString(Prevod.prevod(aktHodnotaY, 10)));
            znackaY.setFont(new Font("SansSerif", Font.PLAIN, 10));
            znackaY.setHorizontalAlignment(JLabel.RIGHT);
            znackaY.setSize(68, 10);
            znackaY.setLocation(0, aktZnackaY - 5);
            add(znackaY);
            g.drawLine(sirkaOsy - 4, aktZnackaY, sirkaOsy, aktZnackaY);
            aktHodnotaY += krokY;
        }
    }

    public void aktualizujGraf(int novyRad) {
        this.rad = novyRad;
        nastavVstupniData();
        vypoctiMaxX();
    }

    private void nastavVstupniData() {
        hodnotySumGenetic = panelVystupniData.dejPoleSumGenetic();
        hodnotySumNelder = panelVystupniData.dejPoleSumNelder();
        hodnotySumCtverce = panelVystupniData.dejPoleSumCtverce();

        pocetHodnotGenetic = hodnotySumGenetic.length;
        pocetHodnotNelder = hodnotySumNelder.length;
        pocetHodnotCtverce = hodnotySumCtverce.length;
    }

    private void vytvorDataVykr() {
        SumGeneticVykr = new int[pocetHodnotGenetic];
        SumNelderVykr = new int[pocetHodnotNelder];
        SumCtverceVykr = new int[pocetHodnotCtverce];

        hodnotyXVykr = new int[(int) maxX];
    }

    private void vypoctiMaxX() {
        if (pocetHodnotGenetic >= pocetHodnotNelder && pocetHodnotNelder >= pocetHodnotCtverce) {
            maxX = pocetHodnotGenetic;
        } else if (pocetHodnotNelder >= pocetHodnotGenetic && pocetHodnotGenetic >= pocetHodnotCtverce) {
            maxX = pocetHodnotNelder;
        } else {
            maxX = pocetHodnotCtverce;
        }
    }

    private void vypoctiMinMaxY() {
        boolean nastaveno = false;
        for (int aktHodnota = 0; aktHodnota < maxX; aktHodnota++) {
            if (aktHodnota < pocetHodnotGenetic && panelLegendaBilySum.CheckBoxYGenetic()) {
                if (!nastaveno) {
                    minY = hodnotySumGenetic[0];
                    maxY = hodnotySumGenetic[0];
                    nastaveno = true;
                }
                if (hodnotySumGenetic[aktHodnota] < minY) {
                    minY = hodnotySumGenetic[aktHodnota];
                }
                if (hodnotySumGenetic[aktHodnota] > maxY) {
                    maxY = hodnotySumGenetic[aktHodnota];
                }
            }
            if (aktHodnota < pocetHodnotNelder && panelLegendaBilySum.CheckBoxYNelder()) {
                if (!nastaveno) {
                    minY = hodnotySumNelder[0];
                    maxY = hodnotySumNelder[0];
                    nastaveno = true;
                }
                if (hodnotySumNelder[aktHodnota] < minY) {
                    minY = hodnotySumNelder[aktHodnota];
                }
                if (hodnotySumNelder[aktHodnota] > maxY) {
                    maxY = hodnotySumNelder[aktHodnota];
                }
            }
            if (aktHodnota < pocetHodnotCtverce && panelLegendaBilySum.CheckBoxYCtverce()) {
                if (!nastaveno) {
                    minY = hodnotySumCtverce[0];
                    maxY = hodnotySumCtverce[0];
                    nastaveno = true;
                }
                if (hodnotySumCtverce[aktHodnota] < minY) {
                    minY = hodnotySumCtverce[aktHodnota];
                }
                if (hodnotySumCtverce[aktHodnota] > maxY) {
                    maxY = hodnotySumCtverce[aktHodnota];
                }
            }
        }
    }

    private void vypoctiPomer() {
        if (maxX > 1) {
            pomerX = (getWidth() - sirkaOsy - 2) / (maxX - 1);
        } else {
            pomerX = 1;
        }

        if (maxY != minY) {
            pomerY = (getHeight() - vyskaOsy - 2) / (maxY - minY);
        } else {
            pomerY = 1;
        }
    }

    private void vypoctiHodnotyVykr() {
        int vyska = getHeight() - vyskaOsy;
        for (int aktHodnota = 0; aktHodnota < maxX; aktHodnota++) {
            hodnotyXVykr[aktHodnota] = (int) (sirkaOsy + 1 + aktHodnota * pomerX);

            if (aktHodnota < pocetHodnotGenetic && panelLegendaBilySum.CheckBoxYGenetic()) {
                SumGeneticVykr[aktHodnota] = (int) (vyska - 2 - pomerY * (hodnotySumGenetic[aktHodnota] - minY));
            }
            if (aktHodnota < pocetHodnotNelder && panelLegendaBilySum.CheckBoxYNelder()) {
                SumNelderVykr[aktHodnota] = (int) (vyska - 2 - pomerY * (hodnotySumNelder[aktHodnota] - minY));
            }
            if (aktHodnota < pocetHodnotCtverce && panelLegendaBilySum.CheckBoxYCtverce()) {
                SumCtverceVykr[aktHodnota] = (int) (vyska - 2 - pomerY * (hodnotySumCtverce[aktHodnota] - minY));
            }
        }
    }
}
