/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Metoda_nejmensich_ctvercu;

/**
 *
 * @author Miraxp
 */
public class Matice {

    private double prvky[][];
    private int pocetSloupcu, pocetRadku;

    public Matice(double novePrvky[][]) {
        prvky = novePrvky;
        pocetRadku = prvky.length;
        pocetSloupcu = prvky[0].length;
    }

    public Matice vynasob(Matice matice) {
        int pocetRadkuMaticeB = matice.dejPocetRadku();
        int pocetSloupcuMaticeB = matice.dejPocetSloupcu();
        if (pocetSloupcu == pocetRadkuMaticeB) {
            double prvkyNasobek[][] = new double[pocetRadku][pocetSloupcuMaticeB];
            double hodnota;
            for (int aktRadek = 0; aktRadek < pocetRadku; aktRadek++) {
                for (int aktSloupec = 0; aktSloupec < pocetSloupcuMaticeB; aktSloupec++) {
                    hodnota = 0;
                    for (int i = 0; i < pocetSloupcu; i++) {
                        hodnota += prvky[aktRadek][i] * matice.dejPrvek(i, aktSloupec);
                    }
                    prvkyNasobek[aktRadek][aktSloupec] = hodnota;
                }
            }
            return new Matice(prvkyNasobek);
        }
        return null;
    }

    public Matice dejTransponovanou() {
        double T[][] = new double[pocetSloupcu][pocetRadku];
        for (int radek = 0; radek < pocetSloupcu; radek++) {
            for (int sloupec = 0; sloupec < pocetRadku; sloupec++) {
                T[radek][sloupec] = prvky[sloupec][radek];
            }
        }
        return new Matice(T);
    }

    private double Determinant(double a[][], int rozmer) {
        int i, j, j1, j2;
        double det = 0;
        double m[][] = null;

        if (rozmer < 1) {
        } else if (rozmer == 1) {
            det = a[0][0];
        } else if (rozmer == 2) {
            det = a[0][0] * a[1][1] - a[1][0] * a[0][1];
        } else {
            det = 0;
            for (j1 = 0; j1 < rozmer; j1++) {
                m = new double[rozmer - 1][rozmer - 1];

                for (i = 1; i < rozmer; i++) {
                    j2 = 0;
                    for (j = 0; j < rozmer; j++) {
                        if (j == j1) {
                            continue;
                        }
                        m[i - 1][j2] = a[i][j];
                        j2++;
                    }
                }
                det += Math.pow(-1.0, 1.0 + j1 + 1.0) * a[0][j1] * Determinant(m, rozmer - 1);
            }
        }
        return (det);
    }

    public double[][] dejMaticiSubdeterminant(int radek, int sloupec) {
        double MS[][] = new double[pocetRadku - 1][pocetSloupcu - 1];
        int indexRadek, indexSloupec;
        for (int aktRadek = 0; aktRadek < pocetRadku - 1; aktRadek++) {
            for (int aktSloupec = 0; aktSloupec < pocetSloupcu - 1; aktSloupec++) {
                if (aktRadek < radek) {
                    indexRadek = aktRadek;
                } else {
                    indexRadek = aktRadek + 1;
                }
                if (aktSloupec < sloupec) {
                    indexSloupec = aktSloupec;
                } else {
                    indexSloupec = aktSloupec + 1;
                }
                MS[aktRadek][aktSloupec] = prvky[indexRadek][indexSloupec];
            }
        }
        return MS;
    }

    public Matice dejInverzni() {
        double det = Determinant(prvky, pocetRadku);
        double I[][] = new double[pocetRadku][pocetSloupcu];
        for (int aktRadek = 0; aktRadek < pocetRadku; aktRadek++) {
            for (int aktSloupec = 0; aktSloupec < pocetSloupcu; aktSloupec++) {
                I[aktRadek][aktSloupec] = (Math.pow(-1, (aktRadek + 1 + aktSloupec + 1)) * Determinant(dejMaticiSubdeterminant(aktSloupec, aktRadek), pocetRadku - 1)) / det;
            }
        }
        return new Matice(I);
    }

    public int dejPocetRadku() {
        return pocetRadku;
    }

    public int dejPocetSloupcu() {
        return pocetSloupcu;
    }

    public double dejPrvek(int radek, int sloupec) {
        return prvky[radek][sloupec];

    }

    public double[][] dejPrvky() {
        return prvky;
    }

    private double[][] dejJednotkovouMatici(int rad) {
        double[][] J = new double[rad][rad];
        for (int radek = 0; radek < rad; radek++) {
            for (int sloupec = 0; sloupec < rad; sloupec++) {
                if (radek == sloupec) {
                    J[radek][sloupec] = 1;
                } else {
                    J[radek][sloupec] = 0;
                }
            }
        }
        return J;
    }

    public void vypis() {
        for (int aktRadek = 0; aktRadek < pocetRadku; aktRadek++) {
            for (int aktSloupec = 0; aktSloupec < pocetSloupcu; aktSloupec++) {
                System.out.print(prvky[aktRadek][aktSloupec] + " ");
            }
            System.out.println("");
        }
    }
}
