/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Nelder_Mead_algoritmus;

import Funkce.Funkce;

/**
 *
 * @author Miraxp
 */
public class Nelder_Mead_algoritmus {

    private Simplex simplex;
    private int pocetNeznamych, pocetVrcholu, cyklus;
    private Funkce funkce;

    public Nelder_Mead_algoritmus(short nPocetNeznamych, Funkce nFunkce) {
        this.pocetNeznamych = nPocetNeznamych;
        this.pocetVrcholu = pocetNeznamych + 1;
        this.funkce = nFunkce;
        this.simplex = new Simplex(nPocetNeznamych, funkce);
    }

    public double[] provedAlgoritmus(int pocetCyklu) {
        cyklus = 0;
        while (cyklus < pocetCyklu && !simplex.jsouSiRovny()) {
            cyklus++;
            //System.out.println("NMA: " + cyklus);

            simplex.seradVrcholy();
            simplex.najdiTeziste();

            double f_nejlepsiho, f_druh_nejhorsiho, f_nejhorsiho, f_bodu_xr, f_bodu_xe, f_bodu_xc;
            f_nejlepsiho = funkce.f(simplex.dejHodnotyVrcholu(0));
            f_druh_nejhorsiho = funkce.f(simplex.dejHodnotyVrcholu(pocetVrcholu - 2));
            f_bodu_xr = funkce.f(simplex.dejHodnotyBoduXR());
// Reflexe
            if (f_nejlepsiho <= f_bodu_xr && f_bodu_xr < f_druh_nejhorsiho) {
                simplex.reflexe();
                continue;
            }
// Expanze
            if (f_bodu_xr < f_nejlepsiho) {
                f_bodu_xe = funkce.f(simplex.dejHodnotyBoduXE());
                if (f_bodu_xe < f_bodu_xr) {
                    simplex.expanze();
                    continue;
                } else {
                    simplex.reflexe();
                    continue;
                }
            }
// Kontrakce
            f_bodu_xc = funkce.f(simplex.dejHodnotyBoduXC());
            f_nejhorsiho = funkce.f(simplex.dejHodnotyVrcholu(pocetVrcholu - 1));
            if (f_bodu_xc < f_nejhorsiho) {
                simplex.kontrakce();
                continue;
            } else {
// Redukce
                simplex.redukce();
                continue;
            }

        }
        simplex.seradVrcholy();
        return simplex.dejHodnotyVrcholu(0);
    }
}
