/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Optimalizace;

import Funkce.Funkce;
import Geneticky_algoritmus.Geneticky_algoritmus;
import Metoda_nejmensich_ctvercu.Metoda_nejmensich_ctvercu;
import Nelder_Mead_algoritmus.Nelder_Mead_algoritmus;

/**
 *
 * @author Miraxp
 */
public class Optimalizace {

    private Funkce funkce;
    private short rad, pocetParametru;
    private double ymk[], u[];
    private Geneticky_algoritmus genetickyAlg;
    private Nelder_Mead_algoritmus nelderMead;
    private Metoda_nejmensich_ctvercu nejCtverce;
    private double vysledkyGenetic[], vysledkyNelderMead[], vysledkyNelderCtverce[];

    public Optimalizace(double nove_ymk[], double nove_u[], short nRad, double geneticPar[], short procentoPrezivsich, short typVyberu) {
        this.rad = nRad;
        this.pocetParametru = (short) (2 * rad);
        this.u = nove_u;
        this.ymk = nove_ymk;

        double parGeneticMinMaxPres[][] = new double[pocetParametru][3];

        for (int aktPar = 0; aktPar < pocetParametru; aktPar++) {
            parGeneticMinMaxPres[aktPar][0] = geneticPar[2];
            parGeneticMinMaxPres[aktPar][1] = geneticPar[3];
            parGeneticMinMaxPres[aktPar][2] = geneticPar[4];
        }

        this.funkce = new Funkce(ymk, u, rad);
        this.genetickyAlg = new Geneticky_algoritmus((short) geneticPar[0], geneticPar[1], parGeneticMinMaxPres, funkce, procentoPrezivsich, typVyberu);
        this.nelderMead = new Nelder_Mead_algoritmus(pocetParametru, funkce);
        this.nejCtverce = new Metoda_nejmensich_ctvercu(ymk, u, rad);
    }

    public void provedOptimalizaci(int pocetCyklu) {
        vysledkyGenetic = genetickyAlg.provedAlgoritmus(pocetCyklu);
        vysledkyNelderMead = nelderMead.provedAlgoritmus(pocetCyklu);
    }

    public void provedOptimalizaciGenetic(int pocetCyklu) {
        vysledkyGenetic = genetickyAlg.provedAlgoritmus(pocetCyklu);
    }

    public void provedOptimalizaciNelder(int pocetCyklu) {
        vysledkyNelderMead = nelderMead.provedAlgoritmus(pocetCyklu);
    }

    public void provedOptimalizaciCtverce() {
        vysledkyNelderCtverce = nejCtverce.provedAlgoritmus();
    }

    public double[] dejVysledkyGenetic() {
        return vysledkyGenetic;
    }

    public double[] dejVysledkyNelderMead() {
        return vysledkyNelderMead;
    }

    public double[] dejVysledkyCtverce() {
        return vysledkyNelderCtverce;
    }
}
